module araliklar_10;

import std.traits;
import std.stdio;
import std.algorithm;

struct ÇokHedefeYazan {
    string ayraç;
    File[] dosyalar;

    this(string ayraç, string[] dosyaİsimleri...) {
        this.ayraç = ayraç;

        /* stdout her zaman dahil */
        this.dosyalar ~= stdout;

        /* Belirtilen her dosya ismi için yeni bir dosya  */
        foreach (dosyaİsmi; dosyaİsimleri) {
            this.dosyalar ~= File(dosyaİsmi, "w");
        }
    }

    /* Dilimlerle kullanılan put() (dizgiler hariç) */
    void put(T)(T dilim)
            if (isArray!T && !isSomeString!T) {
        foreach (eleman; dilim) {
            // Bu, aşağıdaki put()'u çağırmaktadır
            put(eleman);
        }
    }

    /* Dilim olmayan türlerle ve dizgilerle kullanılan put() */
    void put(T)(T değer)
            if (!isArray!T || isSomeString!T) {
        foreach (dosya; dosyalar) {
            dosya.write(değer, ayraç);
        }
    }
}
// ...

void main() {
    auto çıkış = ÇokHedefeYazan("\n", "deneme_0", "deneme_1");
    copy([ 1, 2, 3], çıkış);
    copy([ "kırmızı", "mavi", "yeşil" ], çıkış);
}
