module bellek_yonetimi_7;

size_t boşlukluUzunluk(T)() {
    static if (is (T == class)) {
        size_t uzunluk = __traits(classInstanceSize, T);

    } else {
        size_t uzunluk = T.sizeof;
    }

    return cast(size_t)hizalıAdres(cast(T*)uzunluk);
}
T * hizalıAdres(T)(T * adayAdres) {
    import std.traits;

    static if (is (T == class)) {
        const hizalama = classInstanceAlignment!T;

    } else {
        const hizalama = T.alignof;
    }

    const sonuç = (cast(size_t)adayAdres + hizalama - 1)
                  / hizalama * hizalama;
    return cast(T*)sonuç;
}
import std.stdio;
import std.string;
import core.memory;
import std.conv;

// ...

struct Öğrenci {
    string isim;
    int numara;

    string toString() {
        return format("%s(%s)", isim, numara);
    }
}

void main() {
    /* Önce bu türle ilgili bilgi yazdırıyoruz. */
    writefln("Öğrenci.sizeof: %#x (%s) bayt",
             Öğrenci.sizeof, Öğrenci.sizeof);
    writefln("Öğrenci.alignof: %#x (%s) bayt",
             Öğrenci.alignof, Öğrenci.alignof);

    string[] isimler = [ "Deniz", "Pınar", "Irmak" ];
    const toplamBayt =
        boşlukluUzunluk!Öğrenci() * isimler.length;

    /* Bütün Öğrenci nesnelerine yetecek kadar yer ayırıyoruz.
     *
     * UYARI! Bu dilimin eriştirdiği nesneler henüz
     * kurulmamışlardır. */
    Öğrenci[] öğrenciler =
        (cast(Öğrenci*)GC.calloc(toplamBayt))
            [0 .. isimler.length];

    foreach (i, isim; isimler) {
        Öğrenci * adayAdres = öğrenciler.ptr + i;
        Öğrenci * öğrenciAdresi = hizalıAdres(adayAdres);
        writefln("adres %s: %s", i, öğrenciAdresi);

        const numara = 100 + i.to!int;
        emplace(öğrenciAdresi, isim, numara);
    }

    /* Bütün elemanları kurulmuş olduğundan bir Öğrenci dilimi
     * olarak kullanmakta artık bir sakınca yoktur. */
    writeln(öğrenciler);
}
