module birlikler_2;

import std.stdio;
import std.stdio;
import std.exception;

struct Korumalı {
private:

    TypeInfo geçerliTür_;

    union {
        int i_;
        double d_;
    }

public:

    this(int değer) {
        // Bu atama, aşağıdaki nitelik işlevini çağırır
        i = değer;
    }

    // 'int' üyeyi değiştirir
    void i(int değer) {
        i_ = değer;
        geçerliTür_ = typeid(int);
    }

    // 'int' veriyi döndürür
    int i() const {
        enforce(geçerliTür_ == typeid(int),
                "Veri 'int' değil.");
        return i_;
    }

    this(double değer) {
        // Bu atama, aşağıdaki nitelik işlevini çağırır
        d = değer;
    }

    // 'double' üyeyi değiştirir
    void d(double değer) {
        d_ = değer;
        geçerliTür_ = typeid(double);
    }

    // 'double' veriyi döndürür
    double d() const {
        enforce(geçerliTür_ == typeid(double),
                "Veri 'double' değil." );
        return d_;
    }

    // Geçerli verinin türünü bildirir
    const(TypeInfo) tür() const {
        return geçerliTür_;
    }
}

unittest {
    // 'int' veriyle başlayalım
    auto k = Korumalı(42);

    // Geçerli tür 'int' olarak bildirilmelidir
    assert(k.tür == typeid(int));

    // 'int' veri okunabilmelidir
    assert(k.i == 42);

    // 'double' veri okunamamalıdır
    assertThrown(k.d);

    // 'int' yerine 'double' veri kullanalım
    k.d = 1.5;

    // Geçerli tür 'double' olarak bildirilmelidir
    assert(k.tür == typeid(double));

    // Bu sefer 'double' veri okunabilmelidir ...
    assert(k.d == 1.5);

    // ... ve 'int' veri okunamamalıdır
    assertThrown(k.i);
}
void main() {
    Korumalı[] dizi = [ Korumalı(1), Korumalı(2.5) ];

    foreach (değer; dizi) {
        if (değer.tür == typeid(int)) {
            writeln("'int' veri kullanıyoruz   : ", değer.i);

        } else if (değer.tür == typeid(double))  {
            writeln("'double' veri kullanıyoruz: ", değer.d);

        } else {
            assert(0);
        }
    }
}
