module foreach_opapply_cozum_2;

import std.stdio;
import std.string;

class Öğrenci {
    string isim;
    int numara;

    this(string isim, int numara) {
        this.isim = isim;
        this.numara = numara;
    }

    override string toString() {
        return format("%s(%s)", isim, numara);
    }
}

class Öğretmen {
    string isim;
    string ders;

    this(string isim, string ders) {
        this.isim = isim;
        this.ders = ders;
    }

    override string toString() {
        return format("%s dersine %s Öğretmen", ders, isim);
    }
}

class Okul {
private:

    Öğrenci[] öğrenciler;
    Öğretmen[] öğretmenler;

public:

    this(Öğrenci[] öğrenciler,
         Öğretmen[] öğretmenler) {
        this.öğrenciler = öğrenciler.dup;
        this.öğretmenler = öğretmenler.dup;
    }

    /* Parametresi Öğrenci olduğundan, bu 'delegate'i
     * kullanan opApply, foreach döngü değişkeninin Öğrenci
     * olduğu durumda çağrılır. */
    int opApply(int delegate(ref Öğrenci) işlemler) {
        int sonuç;

        foreach (öğrenci; öğrenciler) {
            sonuç = işlemler(öğrenci);

            if (sonuç) {
                break;
            }
        }

        return sonuç;
    }

    /* Benzer şekilde, bu opApply da foreach döngü değişkeni
     * Öğretmen olduğunda çağrılır. */
    int opApply(int delegate(ref Öğretmen) işlemler) {
        int sonuç;

        foreach (öğretmen; öğretmenler) {
            sonuç = işlemler(öğretmen);

            if (sonuç) {
                break;
            }
        }

        return sonuç;
    }
}

void girintiliYazdır(T)(T nesne) {
    writeln("  ", nesne);
}

void main() {
    auto okul = new Okul(
        [ new Öğrenci("Can", 1),
          new Öğrenci("Canan", 10),
          new Öğrenci("Cem", 42),
          new Öğrenci("Cemile", 100) ],

        [ new Öğretmen("Nazmiye", "Matematik"),
          new Öğretmen("Makbule", "Türkçe") ]);

    writeln("Öğrenci döngüsü");
    foreach (Öğrenci öğrenci; okul) {
        girintiliYazdır(öğrenci);
    }

    writeln("Öğretmen döngüsü");
    foreach (Öğretmen öğretmen; okul) {
        girintiliYazdır(öğretmen);
    }
}
