module sablonlar_ayrintili_9;

import std.string;

string yapıTanımla(string isim, Üyeler...)() {
    /* Üyeler tür ve isim olarak çiftler halinde
     * belirtilmelidir. Önce bunu denetleyelim. */
    static assert((Üyeler.length % 2) == 0,
                  "Üyeler çiftler halinde belirtilmedilir.");

    /* Önce yapı tanımının ilk satırını oluşturuyoruz. */
    string sonuç = "struct " ~ isim ~ "\n{\n";

    foreach (i, parametre; Üyeler) {
        static if (i % 2) {
            /* Tek numaralı parametreler üye isimlerini
             * belirliyorlar. Onları hemen burada kullanmak
             * yerine aşağıdaki 'else' bölümünde Üyeler[i+1]
             * söz dizimiyle kullanacağız.
             *
             * Yine de üye isimlerinin string olarak
             * belirtildiklerini burada denetleyelim. */
            static assert(is (typeof(parametre) == string),
                          "Üye ismi " ~ parametre.stringof ~
                          " string değil.");

        } else {
            /* Bu durumda 'parametre' üyenin türünü
             * belirtiyor. Öncelikle bu parametrenin gerçekten
             * bir tür olduğunu denetleyelim. */
            static assert(is (parametre),
                          parametre.stringof ~ " tür değil.");

            /* Tür ve üye isimlerini kullanarak satırı
             * oluşturuyoruz.
             *
             * Not: Burada Üyeler[i] yerine 'parametre' de
             * yazabilirdik. */
            sonuç ~= format("    %s %s;\n",
                            Üyeler[i].stringof, Üyeler[i+1]);
        }
    }

    /* Yapı tanımının kapama parantezi. */
    sonuç ~= "}";

    return sonuç;
}

import std.stdio;

void main() {
    writeln(yapıTanımla!("Öğrenci",
                         string, "isim",
                         int, "numara",
                         int[], "notlar")());
}
