module tureme_2;

class DemirYoluAracı {
    void ilerle(size_t kilometre) {
        writefln("Araç %s kilometre ilerliyor", kilometre);
    }
}
class Lokomotif : DemirYoluAracı {
}
class Vagon : DemirYoluAracı {
    abstract void bindir();
    abstract void indir();
}
class Tren : DemirYoluAracı {
    // ...

    void istasyondanAyrıl(string istasyon) {
        foreach (vagon; vagonlar) {
            vagon.bindir();
        }

        writefln("%s garından ayrılıyoruz", istasyon);
    }

    void istasyonaGel(string istasyon) {
        writefln("%s garına geldik", istasyon);

        foreach (vagon; vagonlar) {
            vagon.indir();
        }
    }
    Lokomotif lokomotif;
    Vagon[] vagonlar;

    // ...
import std.exception;
// ...

    // ...

    this(Lokomotif lokomotif) {
        enforce(lokomotif !is null, "Lokomotif null olamaz");
        this.lokomotif = lokomotif;
    }

    void vagonEkle(Vagon[] vagonlar...) {
        this.vagonlar ~= vagonlar;
    }

    // ...
}
class YolcuVagonu : Vagon {
    override void bindir() {
        writeln("Yolcular biniyor");
    }

    override void indir() {
        writeln("Yolcular iniyor");
    }
}

class YükVagonu : Vagon {
    override void bindir() {
        writeln("Mal yükleniyor");
    }

    override void indir() {
        writeln("Mal boşalıyor");
    }
}
import std.stdio;
// ...
void main() {
    auto lokomotif = new Lokomotif;
    auto tren = new Tren(lokomotif);

    tren.vagonEkle(new YolcuVagonu, new YükVagonu);

    tren.istasyondanAyrıl("Ankara");
    tren.ilerle(500);
    tren.istasyonaGel("Haydarpaşa");
}
