module yapilar_cozum_1;

import std.stdio;
import std.random;
import std.algorithm;

struct OyunKağıdı {
    dchar renk;
    dchar değer;
}

void oyunKağıdıYazdır(OyunKağıdı kağıt) {
    write(kağıt.renk, kağıt.değer);
}

OyunKağıdı[] yeniSeri(dchar renk)
in {
    assert((renk == '♠') ||
           (renk == '♡') ||
           (renk == '♢') ||
           (renk == '♣'));

} out (sonuç) {
    assert(sonuç.length == 13);

} do {
    OyunKağıdı[] seri;

    foreach (değer; "234567890JQKA") {
        seri ~= OyunKağıdı(renk, değer);
    }

    return seri;
}

OyunKağıdı[] yeniDeste()
out (sonuç) {
    assert(sonuç.length == 52);

} do {
    OyunKağıdı[] deste;

    deste ~= yeniSeri('♠');
    deste ~= yeniSeri('♡');
    deste ~= yeniSeri('♢');
    deste ~= yeniSeri('♣');

    return deste;
}

void karıştır(OyunKağıdı[] deste, int değişTokuşAdedi) {
    /* Not: Daha etkin bir yöntem, desteyi başından sonuna
     *      kadar ilerlemek ve her elemanı destenin sonuna
     *      doğru rasgele bir elemanla değiştirmektir.
     *
     * En doğrusu, zaten aynı algoritmayı uygulayan
     * std.algorithm.randomShuffle işlevini çağırmaktır. Bu
     * karıştır() işlevini bütünüyle kaldırıp main() içinde
     * açıklandığı gibi randomShuffle()'ı çağırmak daha doğru
     * olur. */
    foreach (i; 0 .. değişTokuşAdedi) {

        // Rasgele iki tanesini seç
        immutable birinci = uniform(0, deste.length);
        immutable ikinci = uniform(0, deste.length);

        // Değiş tokuş et
        swap(deste[birinci], deste[ikinci]);
    }
}

void main() {
    OyunKağıdı[] deste = yeniDeste();

    karıştır(deste, 100);
    /* Not: Yukarıdaki karıştır() çağrısı yerine aşağıdaki
     *      randomShuffle() daha doğru olur:
     *
     * randomShuffle(deste);
     */
    foreach (kağıt; deste) {
        oyunKağıdıYazdır(kağıt);
        write(' ');
    }

    writeln();
}
